#ifndef __QBUFFER_H
#define __QBUFFER_H

#include "qiodevice.h"

class QByteArray
{
 protected:
  const char * m_Buffer;
  int m_nSize;
 public:
  QByteArray () { m_Buffer = 0; m_nSize =0 ;}
  ~QByteArray() { delete [] m_Buffer; }
  QByteArray(const QByteArray & a)
    {
      m_Buffer =0; 
      m_nSize=0;
      assign(a.buffer(),a.length());
    }
  QByteArray & assign(const char * a, unsigned int n) 
    { 
      delete [] m_Buffer;
      m_Buffer = new char [n];
      memcpy((char*)m_Buffer,a,n);
      m_nSize = n;
      return *this; 
    }
  int length() const { return m_nSize; }
  const char * buffer() const { return m_Buffer; }
};

class QBuffer : public QIODevice
{
  QByteArray m_Buffer;
 public:
  QBuffer() { }
  virtual int readBlock(char * data, uint maxlen)
    {
      int len = (m_Buffer.length() > maxlen ? maxlen : m_Buffer.length());
      memcpy(data,m_Buffer.buffer(),len );
      
      return len;
    }
  virtual int writeBlock( const char * data, unsigned int len)
    {
      m_Buffer.assign(data,len);
    }
  QByteArray buffer() const { return m_Buffer; }
};



#endif
